import pyglet as p
from collections import deque

batch = p.graphics.Batch()

def reset():
    global batch
    batch = p.graphics.Batch()

p.resource.path = ['resource']
p.resource.reindex()
###images
rocks_image = p.resource.image('rocks.png')
spikes_image = p.resource.image('spikes.png')
loot_image = p.resource.image('loot.png')
gravel_image = p.resource.image('gravel.png')
player_image = p.resource.image('player.png')
###

tile_size = 50 #Make sure it is the same with ball
left_padding = 100
bottom_padding = 50

#I want it to move 50pix in t seconds.
#speed = 50/time
#I want it to move in .5 sec. Speed is 100

move_time = 0.5
move_speed = move_time/tile_size


#def garbage_man(dt):
    #Put this inside of Tile????
    #for tile in updatelist[:]:
    #    if tile.counter > 50:
    #        updatelist.remove(tile)
    #        p.clock.unschedule(tile.animation)
#p.clock.schedule_interval(garbage_man, 1/100)
#updatelist = []
#This here was to implement animations. I have no time however.

def rocks(j, i):
    return Tile(rocks_image, j, i)

def spikes(j, i):
    tile = Tile(spikes_image, j, i)
    tile.kill = True
    return tile

def loot(j, i): #Gravitile?
    tile = GraviTile(loot_image, j, i)
    tile.loot = True
    return tile

def gravel(j, i):
    return GraviTile(gravel_image, j, i)

def player(j, i):
    return GraviTile(player_image, j, i)

def lava(j, i):
    return Tile(lava_image, j, i)

class Tile(p.sprite.Sprite):
    def __init__(self, image, j, i):
        self._i, self._j = i, j
        x = left_padding + j*tile_size
        y = bottom_padding + i*tile_size
        super().__init__(image, x, y, batch=batch)

    def j():
        doc = "The j property."
        def fget(self):
            return self._j
        def fset(self, value):
            self._j = value
            self.x = left_padding + value*tile_size
        def fdel(self):
            del self._j
        return locals()
    j = property(**j())

    def i():
        doc = "The i property."
        def fget(self):
            return self._i
        def fset(self, value):
            self._i = value
            self.y = bottom_padding + value*tile_size
        def fdel(self):
            del self._i
        return locals()
    i = property(**i())

    def animate(self, dir):
        #this is uneeded
        self.counter = 0
        def animation(dt, tile):
            if tile.counter < tile_size:
                tile.counter += 1
                tile.x += dir[0] #one pixel
                tile.y += dir[1]

        self.animation = animation
        updatelist.append(self)
        p.clock.schedule_interval(animation, move_speed, self)

class GraviTile(Tile):
    def fall(self):
        self.i -= 1
        #self.animate((0, -1))

class Deck(deque):
    def rotate(self, degree):
        super().rotate(degree)
        for tile in self:
            try:
                tile.j = (tile.j + degree) % 12 #Number of columns.
                #Shouldn't be here.
                #tile.animate((degree, 0)) #This is uneeded
            except AttributeError: #NoneType.
                ...

class Level(list):
    def __init__(self, tileset):
        '''Transform a list of numbers which represent tiles into the
        actual tiles.
        '''

        self.keylock = False

        temp = tileset[:]
        temp.reverse()
        self.mapsize = len(temp)
        self.killbottom = []
        self.killtop = []

        for i in range(self.mapsize): #line number ###Mapsize?
            self.append(Deck())
            for j, tile in enumerate(temp[i]): #mapsize? #element
                if tile == 0: #empty tile
                    self[i].append(None)
                elif tile == 1: #bricks
                    self[i].append(rocks(j, i))
                elif tile == 2: #spikes
                    self[i].append(spikes(j, i))
                elif tile == 3: #gravel
                    self[i].append(gravel(j, i))
                elif tile == 4: #loot
                    self[i].append(loot(j, i))
                elif tile == 5: #player
                    self.player = player(j, i)
                    self[i].append(self.player)

    def update(self, *a):
        self.keylock = False #if anything happens, change to true.
        for i, line in enumerate(self):
            for j, tile in enumerate(line):
                if i > 0 and hasattr(tile, 'fall'):
                    #If anything happens, put a lock on key.

                    try:
                        below = self[i-1][j]
                        above = self[i+1][j]
                    except IndexError: ...

                    if tile is self.player:
                        if hasattr(below, 'kill'):
                            self.keylock = True
                            return 'end'#Play a sound, block keys? Display restart
                        elif hasattr(below, 'loot'):
                            self.keylock = True
                            return 'win'

                    if not below:
                        self[i-1][j] = tile
                        self[i][j] = None
                        self.keylock = True
                        tile.fall()

                    elif below is self.player:
                        self[i-1][j] = tile
                        self[i][j] = None
                        tile.fall()
                        self.keylock = True
                        return 'end'


            #I can do three things. A: Keep it like this.
            #B: Make tiles aware of their i and j.
            #C: Make a list of things that update, like gravel, and only update them