import sys
from cx_Freeze import setup, Executable

sys.path.insert(0, 'E:/code/Ludum Dare/ludum-dare-26/Lib/site-packages/')
#This only goes for my system. I can't install cx_Freeze on my virtualenv. so
#I need to freeze from my system install, but using the env's packages.

#This can be done within Executable(path =)

includefiles = ['resource', 'README.txt', 'CHANGELOG.txt', 'LICENSE.txt']
packages = ['gamelib', 'collections', 'pyglet']
excludes = ['abc', '_gtkagg', '_tkagg', 'bsddb', 'curses', 'email', 'pywin.debugger',
            'pywin.debugger.dbgcon', 'pywin.dialogs', 'tcl', 'html', 
            'Tkconstants', 'Tkinter']

folderName = sys.platform[:3].upper() if sys.platform != 'darwin' else 'MAC'

build_exe_options = {'packages': packages,
                     'excludes': excludes,
                     'include_files' : includefiles,
                     'include_msvcr' : True,
                     'build_exe' : 'build/Game_of_Rows_' + folderName}


base = None
ext = ''
if sys.platform == 'win32':
    ext = '.exe'
    base = 'Win32GUI'


exe = Executable('run_game.py',
                  targetName = 'Game of Rows' + ext,
                  base=base)

setup(  name = 'Game of Rows',
        version = '1.0',
        author= 'Simon Echeverri / Zim the Fox',
        description = 'My entry for Ludum Dare 26. Theme: Minimalism',
        url = 'http://ludumdare.com/compo/ludum-dare-26/?action=me',
        options = {'build_exe': build_exe_options},
        executables = [exe])
